/*
 * $Id: test.c,v 1.16 1999/12/05 03:22:32 tatuo-y Exp $
 *
 * test
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "sufary.h"

int main(int argc, char *argv[])
{
    char *s;
    SUFARY *ary;
    SUF_RESULT sr;
    DID *did;
    DID_RESULT dr;
    long tmp, pos;
    char didfn[256];

    if (argc != 3) {
	fprintf(stderr, "argument error\n");
    }				/*  */
    sprintf(didfn, "%s.did", argv[2]);

    ary = sa_open(argv[2], NULL);
    if (ary == NULL) {
	printf("error\n");
	exit(1);
    }
     {
	REGEX_RESULT_LIST *ll, *tmp;
	ll = sa_regex(ary, 0, ary->arraysize - 1, argv[1], strlen(argv[1]));
	tmp = ll;

	for (; ll != NULL; ll = ll->next) {
/*
	    printf("--- FOUND '%.*s' from %ld\n",ll->len,
		   sa_txtidx2txtptr(ary, ll->value), ll->value);
		   */
	    s = sa_get_lines(ary, ll->value, 0, 0);	/* Ԥ */
	    printf("%s\n", s);	/* ɽ */
	    free(s);
	}
	free_regex_result_list(tmp);
	exit(1);
    }



    did = sa_open_did(didfn);
    if (did == NULL) {
	printf("error\n");
	exit(1);
    }

    sr = sa_find(ary, 0, ary->arraysize - 1, argv[1], strlen(argv[1]), 0);

    printf("Left %ld, Right %ld\n", sr.left, sr.right);
    printf("ARY_SIZE %ld, DID_SIZE %ld\n", ary->arraysize, did->didsize);

    /*  */
    if (sr.stat == SUCCESS) {
	for (tmp = sr.left; tmp <= sr.right; tmp++) {

	    pos = sa_aryidx2txtidx(ary, tmp);	/* ֤ */
	    s = sa_get_lines(ary, pos, 0, 0);	/* Ԥ */
	    printf("=== pos = %ld\n%s\n", pos, s);	/* ɽ */
	    free(s);

	    dr = sa_didsearch(did, pos);
	    if (dr.no < 0) {
		printf("=== DOCUMENT NOT FOUND\n");
	    } else {
		s = sa_get_string(ary, dr.start, dr.size);
		printf("=== doc_no=%ld\n%s\n", dr.no, s);	/* ɽ */
		free(s);
	    }

	    printf("========================\n");
	}
    } else {
	printf("=== KEYWORD NOT FOUND\n");
    }

    sa_close(ary);		/* եĤ */

    return 0;
}
