/*
 * $Id: SUFARY.xs,v 1.4 1999/12/05 07:18:52 tatuo-y Exp $
 *
 * written by T.Nakayama
 */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "sufary.h"

SUFARY *SUFARYs[256];
char *BUF = NULL;


MODULE = SUFARY PACKAGE = SUFARY

int
suf_openfile(i,s,t)
int i
char *	s
char *	t
CODE:
{
    SUFARYs[i] = sa_open(s,t);
    if (SUFARYs[i] == NULL) {
	RETVAL = 0;
    } else {
	RETVAL = 1;
    }
}
OUTPUT:
RETVAL

void
suf_closefile(i)
int i
CODE:
  {
      SUFARY* ary = SUFARYs[i];
      sa_close(ary);
  }

void
suf_find(i,s,left,right,skip)
int i
char *	s
long left
long right
int skip
PPCODE:
{
    SUF_RESULT sr;
    
    SUFARY* ary = SUFARYs[i];

    sr = sa_find(ary, left, right, s, strlen(s), skip);
    
    if (sr.stat == SUCCESS) {
	EXTEND(sp, 2);
	PUSHs(sv_2mortal(newSVnv(sr.left)));
	PUSHs(sv_2mortal(newSVnv(sr.right)));
    }
}

char *
suf_getline(i,pos)
int i
long pos
CODE:
  {
  SUFARY* ary = SUFARYs[i];

  free(BUF);
  BUF = sa_get_line(ary, pos);

  RETVAL = BUF;
}
OUTPUT:
RETVAL

char *
suf_getstr(i,from,size)
int i
long from
long size
CODE:
  {
  SUFARY* ary = SUFARYs[i];

  free(BUF);
  BUF = sa_get_string(ary, from, size);

  RETVAL = BUF;
}
OUTPUT:
RETVAL

char *
suf_block(i,pos,d1,d2)
int i
long pos
char * d1
char * d2
CODE:
{
  SUFARY* ary = SUFARYs[i];

  free(BUF);
  BUF = sa_get_block(ary, pos, d1, d2);

  RETVAL = BUF;
}
OUTPUT:
RETVAL

long
suf_arraysize(i)
int i
CODE:
{
    SUFARY* ary = SUFARYs[i];

    RETVAL = sa_get_array_size(ary);
}
OUTPUT:
RETVAL

long
suf_aidx2tidx(i,pos)
int i
long pos
CODE:
{
    SUFARY* ary = SUFARYs[i];

    RETVAL = sa_aryidx2txtidx(ary, pos);
}
OUTPUT:
RETVAL

int
suf_line_top_id(id,pos)
int id
long pos
CODE:
{
    long i;
    SUFARY* ary = SUFARYs[id];
    
    i = pos;
    if ((*(sa_get_text_ptr(ary) + pos) == '\n')) {
	i--;
	if (i < 0)
	    i = 0;
    }
    for (;;) {
	if ((*(sa_get_text_ptr(ary) + i) == '\n')) {
	    i++;
	    break;
	}
	if (i == 0)
	    break;
	i--;
    }
    RETVAL = i;
}
OUTPUT:
RETVAL

void
suf_regex_search(i,s)
int i
char *	s
PPCODE:
{
    REGEX_RESULT_LIST *ll, *tmp;
    int count;
    SUFARY* ary = SUFARYs[i];

    ll = sa_regex(ary, 0, sa_get_array_size(ary) - 1, s, strlen(s));

    count = 0;
    for (tmp = ll; tmp != NULL; tmp = tmp->next) count++;
    if (count > 0) {
	EXTEND(sp, count);
	for (tmp = ll; tmp != NULL; tmp = tmp->next) {
	    PUSHs(sv_2mortal(newSVnv(tmp->value)));
	}
	free_regex_result_list(ll);
    }
}

