#-*- perl -*-
package SUFARY;
require 5.000;
#======================================================================
#  = array  - Suffix Array Υƥȸ = 
#                                          Perl Module version
#
#                                            written by T.Nakayama
#======================================================================
require DynaLoader;
@ISA = qw(DynaLoader);
$SUF_MAX = -1;

# 󥹥ȥ饯
sub new {
    my ($class,$textfile,$aryfile) = @_;
    my $self = {};
    bless $self, $class;

    if (++$SUF_MAX >= 256) { return undef; }

    $self->{'id'} = $SUF_MAX;

    if (defined $textfile) {
	if (!(defined $aryfile)) {
	    $aryfile = $textfile . '.ary';
	}
	if (!suf_openfile($self->{'id'}, $textfile, $aryfile)) {
	    return undef;
	}
	$self->{'textfile'} = $textfile;
	$self->{'aryfile'}  = $aryfile;
    }
    # ץν
    $self->{'arraysize'} = suf_arraysize($self->{'id'});

    return $self;
}
# եκƥץ
sub reopen {
    my ($self,$textfile,$aryfile) = @_;

    if (!(defined $textfile)) {$textfile = $self->{'textfile'}}
    if (!(defined $aryfile))  {$aryfile  = $textfile . ".ary"}
    
    if (suf_openfile($self->{'id'}, $textfile, $aryfile)) {
	return 1;
    } else {
	return 0;
    }
}
# եĤ
sub close {
    my $self = shift;

    suf_closefile($self->{'id'});
}
# 
sub search {
    my ($self,$key) = @_;
    my $id = $self->{'id'};

    my @ret =  suf_find($id, $key, 0, $self->{'arraysize'}, 0);

    if ($#ret != 1) {
	@ret = (-1, -2);
    }
    return @ret;
}
# ޥåԤν
sub line {
    my ($self,$ary_idx) = @_;

    my $ti = suf_aidx2tidx($self->{'id'}, $ary_idx);

    return suf_getline($self->{'id'}, $ti);
}
# PID 2 LID
sub txtidx_TOL {
    my ($self,$txt_idx) = @_;

    return suf_line_top_id($self->{'id'}, $txt_idx);
}
# ޥå PID 
sub txtidx {
    my ($self,$ary_idx) = @_;

    return suf_aidx2tidx($self->{'id'}, $ary_idx);
}
# ID -> line
sub get_line {
    my ($self,$txt_idx) = @_;

    return suf_getline($self->{'id'}, $txt_idx);
}
# ֥å
sub get_block {
    my ($self,$txt_idx,$d1,$d2) = @_;

    return suf_block($self->{'id'}, $txt_idx, $d1, $d2);
}
#
sub get_string {
    my ($self, $txt_idx, $size) = @_;

    return suf_getstr($self->{'id'}, $txt_idx, $size);
}

# regex search
sub regex_search {
    my ($self, $key) = @_;

    my @ret = suf_regex_search($self->{'id'}, $key);

    return \@ret;
}

bootstrap SUFARY;
1;
